# =======================================================
# Circle.py: Simplified modeling of a circle ...
# 
# Written by: Mark Austin                   October, 2020 
# =======================================================

import math

class Circle:
  radius = 0
  area   = 0
  perimeter = 0

  def __init__(self, x, y, radius):
    self.radius    = radius
    self.area      = math.pi*radius*radius
    self.perimeter = 2.0*math.pi*radius
    self.x = x
    self.y = y

  # Set circle radius, recompute area and perimeter ...

  def setRadius(self, radius):
    self.radius = radius
    self.area   = math.pi*radius*radius
    self.perimeter = 2.0*math.pi*radius

  # String represention of circle ...

  def __str__(self):
     return "--- Circle: (x,y) = (%.2f, %.2f): radius = %.2f: area = %.2f: perimeter = %.2f" % (
            self.x, self.y, self.radius, self.area, self.perimeter )

