# ===============================================================
# TestDarts01.py: Darts is a Python library for easy manipulation
# and forecasting of time series. This script:
# 
# 1. Create a TimeSeries object from a Pandas DataFrame,
# 2. Split time series into train/validation series:
# 
# ===============================================================

import pandas as pd
from darts import TimeSeries

# main method ...

def main():
    print("--- Enter TestDarts01.main()                ... ");
    print("--- ======================================== ... ");

    # Read a pandas DataFrame

    df = pd.read_csv("../data/AirPassengers.csv", delimiter=",")

    # Create a TimeSeries, specifying the time and value columns

    series = TimeSeries.from_dataframe(df, "Month", "#Passengers")

    # Set aside the last 36 months as a validation series

    train, val = series[:-36], series[-36:]

    print("--- ======================================== ... ");
    print("--- Leave TestDarts01.main()                ... ");

# call the main method ...

main()
