# ============================================================
# Person.py: Simple model of a Person. The scope of variables
# _age and _ssn are protected to Person and all subclasses .. 
# 
# Written by: Mark Austin                        November 2022 
# ============================================================

class Person:
   _age = 0
   _ssn = 0

   # Constructor method ...

   def __init__(self, fname, lname):
     self._firstname = fname
     self._lastname  = lname

   def printname(self):
     print("--- Name: %s, %s" % ( self._firstname, self._lastname) )

   # Get first and last names ...

   def getFirstName(self): 
     return self._firstname 

   def getLastName(self): 
     return self._lastname 

   # Set/get/print age ...

   def setAge(self, age):
     self._age = age

   def getAge(self):
     return self._age

   def printAge(self):
     print("--- Age = %d " % (self._age) )

   # Set/get/print social security number ...

   def setSSN(self, ssn ):
     self._ssn = ssn

   def getSSN(self):
     return self._ssn

   def printSSN(self):
     print("--- Social Security No: %d " % (self._ssn) )

   # return string represention of object ...

   def __str__(self):
       return "Person: %6.2f %6.2f: age = %f " % ( self._firstname, self._lastname, self._age )


